#include <asm/io.h>		// alternate place of io.h 
//#include <sys/io.h>
#include <stdlib.h>
#include <tiffio.h>
#include <sys/time.h>
#include <unistd.h>
#include "pxscan.h"
#include"registers.h"


static unsigned short port = PORT;
//static int dbg_level = DBG_HIGH;
static int dbg_level = DBG_TIMEOUT;
static int port_feature;
static int port_ctrl;
static unsigned char port_mode;
static int last_set_mode = -1;  /* Mode from last epp_set_mode() */
extern int quietflag;

////////////////////////////////////////////////////////////////
//
// set up printer port address
//
void set_port( int portval )
{
	port=portval;
	     DBG(DBG_HELPERS, "  port:               0x%03x\n", port);

}

/*-------------------------------------------------------------*/
void epp_off(void) 
{

    DBG(DBG_LOW,"epp_off:\n");
    /*Restore Port-Mode*/
    if (port_feature & 0x010 ){ 
	outb(port_mode, port + 0x402);
    }
printf("port_ctrl= %X\n",port_ctrl);
    outb(port_ctrl,port+2);
    ioperm(port,16,0);			// free the printerport
    iopl(0);				// give up all i/o rights
}

/*-------------------------------------------------------------*/
void epp_on(void)
{
    DBG(DBG_LOW,"epp_on:\n");

    if( ioperm(port,3,1) ){
	fprintf(stderr, "Could not unlock the printerport. Are you superuser?\n");
	exit(1);
    }
// ok, we got the printerport, now take all iospace

    if (iopl(3)) {
	fprintf(stderr, "Could not unlock IO ports. Are you superuser?\n");
	exit(1);
    }
    port_ctrl=inb(port+2);

    port_feature = port_probe(port,quietflag);
//printf("port_feature= %x\n",port_feature);
//    if(port_feature==0) {
//        printf("No printer port found at %X !\n",port);
//	exit(1);
//    }    

    if (!(port_feature & 0x300 )){ 
	fprintf(stderr, "\nThis Port supports not the  EPP-Mode\n");
	fprintf(stderr, "Please activate EPP-Mode or\nEPP + ECP-Mode!\n");
	exit(1);
    };
   
    if( port_feature & 0x010 ){
	/* Port is ECP with EPP present*/
	/* switching Port to EPP */ 		

	port_mode = inb(port + 0x402);
#ifdef SOFTEPP
#else
//	outb((port_mode & 0x17) | 0x94, port + 0x402); 
	outb( (port_mode & 0x1f) | 0x80, port + 0x402);
//printf("extended control port set to: %X\n", inb(port+0x402));
#endif
    };

//outb(0x04, port+2 );	// set output
//outb(0x01, port+1) ; // clear timeout bit



}

/*-------------------------------------------------------------*/
/*
 * resets a timer
 */
inline void init_timer(long long *timer, unsigned long us)
{
    struct timeval start_time;
    
    gettimeofday(&start_time, NULL);	
    *timer =  start_time.tv_sec * 1e6 + start_time.tv_usec + us;

    DBG(DBG_TIMEOUT, "init_timer:  %i.%i s   wait until:  %Li \n", 
	(int)start_time.tv_sec, (int)start_time.tv_usec, *timer);
}
  
/*-------------------------------------------------------------*/
/*
 * checks for timeout 
 */
inline int check_timer(long long *timer) 
{
    struct timeval current_time;
    
    gettimeofday(&current_time, NULL);

    /*DBG(DBG_TIMEOUT,"check_timer:  %i.%i s\n", 
      (int)current_time.tv_sec, (int)current_time.tv_usec);   */
    if (current_time.tv_sec * 1e6 + current_time.tv_usec > *timer)
	return TIMEOUT;
    else
	return NO_TIMEOUT;
}

/*-------------------------------------------------------------*/
int clear_timeout(void)
{
    unsigned char data = 0;

return NO_TIMEOUT;		// !!!!!


    data = inb(port + 1);
    if (data & 0x01) {
	outb(0x01 , port + 1);
	DBG(DBG_TIMEOUT, "timeout: %02x -- we are in trouble\n", data);
	return TIMEOUT;
    }
    return NO_TIMEOUT;
} 

/*-------------------------------------------------------------*/
/* 
 * Sets mode of next read/write operation from/to BASE+4.  
 * Does nothing if already in right mode
 */
int epp_set_mode(unsigned char mode) 
{
//    int status;
    
    if (mode > 0x1F){							//*gk need 0x1f here
	printf("epp_set_mode:  error, mode %02x > 0x0F  \n",mode);
	exit(1);
    }

//    if (last_set_mode != mode) {
//	if ((status = clear_timeout()))
//	    return status;

#ifdef SOFTEPP

//	while( !(inb(port+1)&0x80));		// wait for nWAIT low, inverted by hw ( EPP1.9 )
	outb( mode, port);			// output data
	outb( 0x05, port+0x02);			// assert vWRITE	
	outb( mode, port);			// output data again
	outb( 0x0d, port+2);			// assert nADDRSTB
	while( (inb(port+1)&0x80));		// wait for nWAIT high
	outb( 0x05, port+2);			// deassert nADDRSTB
	outb( 0x24, port+2);			// 0x04 deassert nWRITE, leave in utput mode

#else
//	outb(0x01, port+1);			// clear the time-out bit
	outb(0x04,port+2); 			// for EPP1.7 only?
//	outb(0x05,port+2); 			// for EPP1.9 only?

	outb(mode, port + 3);
//printf("ctrlport= %X dtaport= %X \n",inb(port+2),inb(port));


//	outb(0x01, port+1);			// clear the time-out bit
#endif
//	if ((status = clear_timeout()))
//	    return status;
	last_set_mode = mode;
//    }
//if( inb(port+1)&1 ) printf("Mode write time out\n"); else printf("mode set to %i\n",mode);
// while(1);
    return NO_TIMEOUT;
}

//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
// NEW VERSION OF WAKEUP
/*-------------------------------------------------------------*/
/*
 * switching the scanner online
 */

/* Send Switcher Clock 1010 via D7 needed for one write-cycle to D1 */
void switcher_clock(void) {
    int i;
    i=inb(port);
    i=i | 0x80; outb (i,port); // D7 = 1
    i=i & 0x7f; outb (i,port);// D7 = 0
    i=i | 0x80; outb (i,port);// D7 = 1
    i=i & 0x7f; outb (i,port);// D7 = 0    
}

/* Set D1 to 0 */
void switcher_d10 (void) {
    int i;
    i=inb(port) & 0xfd;
    outb (i,port);
}

/* Set D1 to 1 */
void switcher_d11 (void) {
    int i;
    i=inb(port) | 0x02;
    outb (i,port);
}

/* Send Switcher ID 1010 via D1 and Switcher Clock via D7 */
void switcher_a9394(void) {
    switcher_d11(); switcher_clock(); // Latch 1 into D1
    switcher_d10(); switcher_clock(); // Latch 0 into D1
    switcher_d11(); switcher_clock(); // Latch 1 into D1
    switcher_d10(); switcher_clock(); // Latch 0 into D1
}

/* Send Switcher ID 1111 via D1 and Switcher Clock via D7 */
void switcher_f9394(void) {
    switcher_d11(); switcher_clock(); // Latch 1 into D1
    switcher_d11(); switcher_clock(); // Latch 1 into D1
    switcher_d11(); switcher_clock(); // Latch 1 into D1
    switcher_d11(); switcher_clock(); // Latch 1 into D1
}

/* Send EPP ID 1001 to Switcher via D1 and Switcher Clock via D7 */
void switcher_epp (void) {
    switcher_d11(); switcher_clock(); // Latch 1 into D1
    switcher_d10(); switcher_clock(); // Latch 0 into D1
    switcher_d10(); switcher_clock(); // Latch 0 into D1
    switcher_d11(); switcher_clock(); // Latch 1 into D1
}

/* Switch the scanner online */
/* returns port status register */
    
unsigned char switcher_online (void) {
    outb (0xff,port); // data bus=1
    outb (0xc4,port+2); // all control signal real output is HIGH
    // switcher reset
    outb (0xff,port);
    outb (0xfe,port);
    outb (0xff,port);
    // Pass-Thru off
    outb (0xff,port);
    // Switcher ID (assuming A93/A94)
    switcher_a9394();
    // EPP ID
    switcher_epp();
    // let ASIC work
    outb (0xfe,port);
    outb (0xff,port);

	return inb(port+1);
}

/* Switch scanner offline - back to printer pass thru */
void switcher_offline (void) {
    outb (0xff,port); // data bus=1
    outb (0xc4,port+2); // all control signal real output is HIGH
    // switcher reset
    outb (0xff,port);
    outb (0xfe,port);
    outb (0xff,port);
    // Pass-Thru on
    outb (0xfb,port);
    // Switcher ID (assuming A93/A94)
    switcher_a9394();
    // EPP ID
    switcher_epp();
}












//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

//-------------------------------------------------------------
//
// switches the scanner online or offline
// onoff bit2: 0=off 1=on
//
// value: high nibble is 'switcher id' ( = 1010 )
//        low nibble is 'EPP id' ( = 1001 )
//


void qqwakeup_2(unsigned char value,unsigned char onoff){

    unsigned char back, code;
    int i;


    back = inb(port + 0x402);
//  printf("ECP control register: %02x\n", back);
outb(0x35,port+0x402);	// set bidir mode
    onoff&=0x04;				// get bit 2 only
    outb(0xFF, port);   

outb(0xc0,port+2);	// reset pulse for scope trigger

    outb(0xc4, port + 2);
//    outb(0x04, port + 2);
    outb(0xFF, port);
    outb(0xFE, port);				// reset
//usleep(100);			// just in case..
    outb(0xFF, port);

//usleep(10);

//printf("onoff=%0x\n",onoff);
    for (i = 7; i>=0; i--){
        code = ((value >> i) & 0x01) << 1;
	code=code|onoff;			// merge with the on/off-line flag
        outb(0x79 + code, port);		// send a double clock pulse
        outb(0xF9 + code, port);
//usleep(10);
        outb(0x79 + code, port);
        outb(0xF9 + code, port);
        outb(0x79 + code, port);
//usleep(10);
    }
//dbgstop(1);

    if( onoff==0x04 ) {    
outb(0xff, port); 			// no, don't use 0xff here ???????????????
       outb(0xFE, port);			// let the ASIC work
       outb(0xFF, port);
    }
//printf("wakeup/down done\n");	//	back=getchar();

outb(back,port+0x402);
printf("U\n");
}



/*-------------------------------------------------------------*/
//   programmed input routine

unsigned char pgmin()
{
unsigned char gkdata;

//	while( !(inb(port+1)&0x80));		// wait for nWAIT low ( EPP1.9 )
	outb( 0x24, port+0x02);			// set input direction
	outb( 0x26, port+2);			// assert nDATASTB
	while( (inb(port+1)&0x80));		// wait for nWAIT high
	gkdata=inb(port);			// capture data here?
	outb( 0x24, port+2 );			// deassert nDATASTB and keep input dir

	return gkdata;
}		

/*
 *
 * read one byte from scanner 
 */

int epp_read_one(unsigned char *data, unsigned char mode) {   
    return epp_read(data, 1, mode);}

/* 
 * reads num bytes from scanner 
 */

int epp_read(unsigned char *data, int num, unsigned char mode) 
{
    int i, status;

    epp_set_mode(mode);
    outb( 0x24, port+2 );	// EPP 1.9 only? // set input direction
//    outb( 0x04, port+2 );	// EPP 1.7 only? // set input direction
//inb(port+1);	// read status  ???

#ifdef SOFTEPP
    status=0;			// fake ok status
#else
//    if ((status = clear_timeout()))
//	return status;
#endif

    for (i = 0; i < num; i++)
#ifdef SOFTEPP
	data[i] = pgmin();
#else
        data[i] = inb(port + 4);

    if ((status = clear_timeout()))
	return status;
#endif

    if (num == 1)
	DBG(DBG_LOW, "epp_read:  %4x           %02x  %02x\n",num,mode, data[0]);
    else
	DBG(DBG_LOW, "epp_read:  %4x           %02x   --  \n",num, mode);
    return status;
}

/*-------------------------------------------------------------*/

// programmed output routine

inline void pgmout(unsigned char databyte)
{
#ifdef SOFTEPP
//	while( !(inb(port+1)&0x80));		// wait for nWAIT low ( EPP1.9 )
	outb( databyte, port);			// output data to port register
	outb( 0x04, port+0x02);			// set output
	outb( databyte, port);			// output data to port register again?
	outb( 0x05, port+0x02);			// assert nWRITE and keep output

	outb( 0x07, port+2);			// assert nDATASTB

	while( (inb(port+1)&0x80));		// wait for nWAIT high
	outb( 0x05, port+2);			// deassert nDATASTB
outb( 0x04, port+2);		// deassert nWRITE

	return;
#else
	outb(databyte, port + 4);		// use EPP data port
#endif		
}

/*
 * write one byte to scanner
 */

int epp_write_one(unsigned char data, unsigned char mode) { 
    return epp_write(&data, 1, mode);}

/*
 * write num bytes to scanner
 */

int epp_write(unsigned char *data, int num, unsigned char mode) 
{
    int i, status;

    epp_set_mode(mode);

#ifdef SOFTEPP
#else
    if ((status = clear_timeout()))
	return status;
//    outb( 0x04, port+2 );	// set output direction
#endif

//outb(0x01,port+1);	// try to clear time-out bit
if(inb(port+1)&1) printf("timeout bit didn't reset, status=%x \n",inb(port+1) );



#ifdef SOFTEPP
#else
outb(0x04,port+2); 		// for EPP1.7 only?
//outb(0x05,port+2); 		// for EPP1.9 only?
#endif
    for (i = 0; i < num; i++)
#ifdef SOFTEPP
	pgmout(data[i]);	
#else
// outb(0x01, port+1);	// clear old timeout ?? NO, DON'T DO THIS!
    outb(data[i], port + 4);

    if ((status = clear_timeout()))
	return status;
#endif
    if (num == 1)
	DBG(DBG_LOW, "epp_write: %4x  %02x  %02x\n", 
	    num, mode, data[0]);
    else
	DBG(DBG_LOW, "epp_write: %4x  %02x   --\n",num, mode);
    return status;
}
